// GETVERDOS Function ruft die Krnl386 function
// GetVersion,wobei nur die DOS Version wird abgefragt.
//  Bereich berprffung unbedingt abschalten !!
// z.b.
// procedure TForm1.SpeedButton1Click(Sender: TObject);
// {$R-}
// begin
//  Label1.Caption:=format('%d.%d', [HiByte(Call16.GetVerDOS),
//                          LoByte(Call16.GetVerDOS)]);
//  {$R+}
//end;
//
//
//
// GetFreeSystemResources ist 32 Bit implementation von WinAPI 16
// GetFreeSystemResources.Der Systax ist gleich wie beim Original.
//
//


unit Call16;

interface
{-----------------------------------------------------------------------------}
const
  Gfsr_SystemResources = 0;
  Gfsr_GdiResources = 1;
  Gfsr_UserResources = 2;

function GetFreeSystemResources(SysResource: Word): Word;
function GetVerDOS:LongInt;
{-----------------------------------------------------------------------------}
implementation

uses SysUtils, Windows;

function LoadLibrary16(LibraryName: PChar): THandle; stdcall; external kernel32 index 35;
procedure FreeLibrary16(HInstance: THandle); stdcall; external kernel32 index 36;
function GetProcAddress16(Hinstance: THandle; ProcName: PChar): Pointer; stdcall; external kernel32 index 37;
procedure QT_Thunk; cdecl; external kernel32 name 'QT_Thunk';

var
  hInst16: THandle;
  GFSR: Pointer;
{$StackFrames On}
{-----------------------------------------------------------------------------}
function GetVerDOS:LongInt;
var
  ThunkTrash: array[0..$20] of Word;
begin
  ThunkTrash[0] := hInst16;

  hInst16 := LoadLibrary16('Krnl386.exe');
  if hInst16 < 32 then
    raise Exception.Create('Cannot load Krnl386.exe');

  FreeLibrary16(hInst16);

  GFSR := GetProcAddress16(hInst16,'GetVersion');
  if GFSR = nil then
    raise Exception.Create('Cannot get address of GetVersion');

  asm
    mov edx, GFSR
    call QT_Thunk
    mov Result,edx   
  end;
end;
{-----------------------------------------------------------------------------}
function GetFreeSystemResources(SysResource: Word): Word;
var
  ThunkTrash: array[0..$20] of Word;
begin

  ThunkTrash[0] := hInst16;
    hInst16 := LoadLibrary16('user.exe');
    if hInst16 < 32 then
      raise Exception.Create('Cannot load USER.EXE');

  FreeLibrary16(hInst16);

  GFSR := GetProcAddress16(hInst16, 'GetFreeSystemResources');
  if GFSR = nil then
    raise Exception.Create('Cannot get address of GetFreeSystemResources');
  asm
    push SysResource
    mov edx, GFSR
    call QT_Thunk
    mov Result, ax
  end;
end;
{-----------------------------------------------------------------------------}
end.

